text = "NOTEHING YET"
text2 = "STILL NOTHING"
r = 0
circles = -1
rects = -1
cfirstX = 0
cfirstY = 0
rfirstX = 0
rfirstY = 0
rxl = 0
ryl = 0
ropePoints = {}

lastbody = nil
function love.load()
  world = love.physics.newWorld(0, 9.81*64, true) --create a world for the bodies to exist in with width and height of 2,000
  love.physics.setMeter(64) --the height of a meter in this world will be 64px
 
  bodies = {} --create tables for the bodies and shapes so that the garbage collector doesn't delete them
  shapes = {}
  circlebodies = {} --circle bodies & shapes
  circleshapes = {}
  rectbodies = {} --rect bodies & shapes
  rectshapes = {}
  fixtures = {}
  --let's create the ground
  --we need to give the ground a mass of zero so that the ground wont move
  bodies[0] = love.physics.newBody(world, 1024/2, 625, 0, 0) --remember, the body anchors from the center of the shape
  shapes[0] = love.physics.newRectangleShape(0, 0, 1024, 50, 0) --anchor the shape to the body, and make it a width of 650 and a height of 50
  fixtures[0] = love.physics.newFixture(bodies[0],shapes[0],1)
  
  --let's create a ball
  bodies[1] = love.physics.newBody(world, 650/2, 650/2,"dynamic") --place the body in the center of the world, with a mass of 15
  shapes[1] = love.physics.newCircleShape(0, 0, 20) --the ball has a shape of 20
  fixtures[1] = love.physics.newFixture(bodies[1],shapes[1],1)
  bodies[1]:setMass(0)
  fixtures[1]:setCategory(1)
  --initial graphics setup
  love.graphics.setBackgroundColor(104, 136, 248) --set the background color
  love.graphics.setMode(1024, 768, false, true, 0) --set the window dimensions
end


function love.update(dt)
  world:update(dt) --this puts the world into motion
	fps = love.timer.getFPS()
  --here we are going to create some keyboard events
	if love.keyboard.isDown("right") then --press the right arrow key to push the ball to the right
		bodies[1]:applyForce(400, 0)
	elseif love.keyboard.isDown("left") then --press the left arrow key to push the ball to the left
		bodies[1]:applyForce(-400, 0)
	elseif love.keyboard.isDown("up") then --press the up arrow key to set the ball in the air
		bodies[1]:applyLinearImpulse(0,-50)
	elseif love.keyboard.isDown("down") then --press the up arrow key to set the ball in the air
		bodies[1]:applyLinearImpulse(0,50)
	end
	create_rects()
	create_circles()
	if (lastbody) then
		local mouseX = love.mouse.getX()
		local mouseY = love.mouse.getY()
		local bodyX = lastbody:getX()
		local bodyY = lastbody:getY()
		local xdist = mouseX - bodyX
		local ydist = mouseY - bodyY
		--lastbody:setLinearVelocity(xdist * 8,ydist * 8)
		lastbody:setPosition(mouseX,mouseY)
	end
	
	if(lastbody) then
		ropePoints = {}
		
		local bodyx,bodyy = lastbody:getWorldCenter()
		local x1 = bodyx
		local y1 = bodyy
		local x2 = love.mouse.getX()
		local y2 = love.mouse.getY()
		local segments = 8
		
		local xlength = x2 - x1
		local ylength = y2 - y1
		for i = 0, segments, 1 do
			local pointX = x1 + xlength * (i/segments)
			local pointY = y1 + ylength * (i/segments)
			ropePoints[#ropePoints + 1] = {pointX,pointY}
			
		end
	end
	if(newMouseJoint) then
		newMouseJoint:setTarget(love.mouse.getPosition())
	end
	if(newRopeJoint) then
		xPos,yPos = lastbody:getWorldCenter()
		newRopeJoint[1].body:setPosition(xPos,yPos)
	end
end

function love.draw()
	love.graphics.setColor(72, 160, 14) --set the drawing color to green for the ground
	love.graphics.polygon( "fill",bodies[0]:getWorldPoints(shapes[0]:getPoints()))
	love.graphics.setColor(193, 47, 14) --set the drawing color to red for the ball
	love.graphics.circle("fill", bodies[1]:getX(), bodies[1]:getY(), shapes[1]:getRadius(), 20)
	love.graphics.print("FPS: "..fps, 50, 50)
	love.graphics.print(text, 300, 325)
	love.graphics.print(text2, 300, 300)

	love.graphics.circle("fill", cfirstX, cfirstY,r, 50)
	love.graphics.rectangle("fill", rfirstX, rfirstY, rxl, ryl)
	love.graphics.setColor(0,0,0)
	love.graphics.setLine( 1.5, "smooth" )
	for i = 0, circles do
		love.graphics.setColor(193, 47, 14)
		love.graphics.circle("fill", circlebodies[i]:getX(), circlebodies[i]:getY(),circleshapes[i]:getRadius(), 50)
		love.graphics.setColor(0,0,0)
		love.graphics.circle("line", circlebodies[i]:getX(), circlebodies[i]:getY(),circleshapes[i]:getRadius(), 50)
	end
	for i = 0, rects do
		love.graphics.setColor(193, 47, 14)
		love.graphics.polygon( "fill", rectbodies[i]:getWorldPoints(rectshapes[i]:getPoints() ))
		love.graphics.setColor(0,0,0)
		love.graphics.polygon( "line", rectbodies[i]:getWorldPoints(rectshapes[i]:getPoints() ))
	end
	love.graphics.circle("line", cfirstX, cfirstY,r, 50)
	love.graphics.rectangle("line", rfirstX, rfirstY, rxl, ryl)
	
	love.graphics.setPointSize(5)
	if(newRopeJoint) then
		for i,v in pairs(newRopeJoint) do
			local bodyX,bodyY = v.body:getWorldCenter()
			love.graphics.setColor(0,0,0)
			love.graphics.point(bodyX,bodyY)
			love.graphics.setColor(0,255,0)
			love.graphics.print(i,bodyX,bodyY)
			
			if not(i==1) then
				local lastBX,lastBY = newRopeJoint[i-1].body:getWorldCenter()
				love.graphics.line(bodyX,bodyY,lastBX,lastBY)
			end
		end
	end
end

function create_circles()
	if (love.mouse.isDown("l")) then
		cfirstpress = true
	else
		cfirstpress = false
		if(r > 1) then
			circles = circles + 1
			circlebodies[circles] = love.physics.newBody(world, cfirstX, cfirstY,"dynamic")
			circleshapes[circles] = love.physics.newCircleShape(r)
			fixtures[#fixtures + 1] = love.physics.newFixture(circlebodies[circles],circleshapes[circles],1)
			circlebodies[circles]:resetMassData( )
			lastbody = circlebodies[circles]
			lastbody:setMass(5000)
			local bodyX,bodyY = lastbody:getWorldCenter()
			local body2X,body2Y = bodies[1]:getWorldCenter()
			if(newRopeJoint) then
				destroyOldRope()
			end
			newRopeJoint = ropeJoint(lastbody, bodies[1], bodyX, bodyY, body2X, body2Y,8)
			--newMouseJoint = love.physics.newMouseJoint(lastbody,bodyX,bodyY)
			fixtures[#fixtures]:setCategory(1)
		end
		cfirstX = love.mouse.getX()
		cfirstY = love.mouse.getY()
		r = 0
		
	end
	if(love.mouse.isDown("l")) and (cfirstpress == true) then
		--So, if grabbed:
		local xl = math.abs(cfirstX - love.mouse.getX())
		local yl = math.abs(cfirstY - love.mouse.getY())
		r = math.sqrt(xl*xl+yl*yl)
	end
end

function create_rects()
	if (love.mouse.isDown("r")) then
		rfirstpress = true
	else
		rfirstpress = false
		if (rxl < -5 or rxl > 5) and (ryl < -5 or ryl > 5) then
			rects = rects + 1
			rectbodies[rects] = love.physics.newBody(world, rfirstX + rxl / 2, rfirstY + ryl / 2,"dynamic")
			rectshapes[rects] = love.physics.newRectangleShape(0,0,rxl,ryl, 0)
			fixtures[#fixtures + 1] = love.physics.newFixture(rectbodies[rects],rectshapes[rects],1)
			rectbodies[rects]:resetMassData( )
			text2 = rectbodies[rects]:getX().."&"..rectbodies[rects]:getY()
			text = rxl.."&"..ryl
			
			lastbody = rectbodies[rects]
		end
		rfirstX = love.mouse.getX()
		rfirstY = love.mouse.getY()
		rxl = 0
		ryl = 0
	end
	if(love.mouse.isDown("r")) and (rfirstpress == true) then
		--So, if grabbed:
		rxl = (love.mouse.getX() - rfirstX)
		ryl = (love.mouse.getY() - rfirstY)
	end	
end

function ropeJoint2(body1,body2,x1,y1,x2,y2,segments)  --USIGN ROPEJOINTS
	local ropePoints = {}
	local xlength = x2 - x1
	local ylength = y2 - y1
	for i = 0, segments, 1 do
		local pointX = x1 + xlength * (i/segments)
		local pointY = y1 + ylength * (i/segments)
		ropePoints[#ropePoints + 1] = {pointX,pointY}
	end
	local ropeJoint = {}
	for i,v in pairs(ropePoints) do
		local newBody = nil
		if( i == 1) then
			newBody = love.physics.newBody(world,v[1],v[2],"static")
			print("y0")
		elseif ( i > 1) then
			newBody = love.physics.newBody(world,v[1],v[2],"dynamic")
			print("y1")
		else
			print("wat?")
		end
		local newChainPiece = love.physics.newCircleShape(1)
		local newFixture = love.physics.newFixture(newBody,newChainPiece)
		newFixture:setMask(2,1)
		newFixture:setCategory(2)
		newBody:setMass(0)
		local newJoints = {}
		if(i == 1) then
			local length = math.sqrt((v[1] - x1)^2 + (v[2] - y1)^2)
			newJoints[1] = love.physics.newRopeJoint(body1,newBody,x1 * 64,y1 * 64,v[1] * 64,v[2] * 64, length,false)
			print("first")
		elseif (i == #ropePoints) then
			local lastX,lastY = ropeJoint[i - 1].body:getWorldCenter()
			local length = math.sqrt((v[1] - lastX)^2 + (v[2] - lastY)^2)
			newJoints[1] = love.physics.newRopeJoint(ropeJoint[i - 1].body,newBody,lastX * 64,lastY * 64,v[1] * 64,v[2] * 64, length ,false)
			local length = math.sqrt((x2 - v[1])^2 + (y2 - v[2])^2)
			newJoints[2] = love.physics.newRopeJoint(newBody,body2,v[1] * 64,v[2] * 64,x2 * 64,y2 * 64, length,false)
			print("second")
		elseif(i > 1 and i < #ropePoints) then
			local lastX,lastY = ropeJoint[i - 1].body:getWorldCenter()
			local length = math.sqrt((v[1] - lastX)^2 + (v[2] - lastY)^2)
			newJoints[1] = love.physics.newRopeJoint(ropeJoint[i - 1].body,newBody,lastX * 64,lastY * 64,v[1] * 64,v[2] * 64, length,false)
			print("third")
		end
		ropeJoint[#ropeJoint + 1] = {}
		ropeJoint[#ropeJoint].body = newBody
		ropeJoint[#ropeJoint].chainPiece = newChainPiece
		ropeJoint[#ropeJoint].fixture = newFixture
		ropeJoint[#ropeJoint].joints = newJoints
	end
	return ropeJoint
end

function ropeJoint(body1,body2,x1,y1,x2,y2,segments)  --USING DISTANCEJOINTS
	local ropePoints = {}
	local xlength = x2 - x1
	local ylength = y2 - y1
	for i = 0, segments, 1 do
		local pointX = x1 + xlength * (i/segments)
		local pointY = y1 + ylength * (i/segments)
		ropePoints[#ropePoints + 1] = {pointX,pointY}
	end
	local ropeJoint = {}
	for i,v in pairs(ropePoints) do
		local newBody = nil
		if( i == 1) then
			newBody = love.physics.newBody(world,v[1],v[2],"static")
			print("y0")
		elseif ( i > 1) then
			newBody = love.physics.newBody(world,v[1],v[2],"dynamic")
			print("y1")
		else
			print("wat?")
		end
		local newChainPiece = love.physics.newCircleShape(1)
		local newFixture = love.physics.newFixture(newBody,newChainPiece)
		newFixture:setMask(2,1)
		newFixture:setCategory(2)
		newBody:setMass(10/ i)
		local newJoints = {}
		if(i == 1) then
			newJoints[1] = love.physics.newDistanceJoint(body1,newBody,x1,y1,v[1],v[2],false)
			print("first")
		elseif (i == #ropePoints) then
			local lastX,lastY = ropeJoint[i - 1].body:getWorldCenter()
			newJoints[1] = love.physics.newDistanceJoint(ropeJoint[i - 1].body,newBody,lastX,lastY,v[1],v[2] ,false)
			newJoints[2] = love.physics.newDistanceJoint(newBody,body2,v[1],v[2],x2,y2,false)
			print("second")
		elseif(i > 1 and i < #ropePoints) then
			local lastX,lastY = ropeJoint[i - 1].body:getWorldCenter()
			newJoints[1] = love.physics.newDistanceJoint(ropeJoint[i - 1].body,newBody,lastX,lastY,v[1],v[2],false)
			print("third")
		end
		ropeJoint[#ropeJoint + 1] = {}
		ropeJoint[#ropeJoint].body = newBody
		ropeJoint[#ropeJoint].chainPiece = newChainPiece
		ropeJoint[#ropeJoint].fixture = newFixture
		ropeJoint[#ropeJoint].joints = newJoints
	end
	return ropeJoint
end


function ropeJoint2(body1,body2,x1,y1,x2,y2,segments)  --USING REVOLUTEJOINTS
	ropePoints = {}
	local xlength = x2 - x1
	local ylength = y2 - y1
	for i = 0, segments, 1 do
		local pointX = x1 + xlength * (i/segments)
		local pointY = y1 + ylength * (i/segments)
		ropePoints[#ropePoints + 1] = {pointX,pointY}
	end
	ropeJoint = {}
	for i,v in pairs(ropePoints) do
		local newBody = love.physics.newBody(world,v[1],v[2],"dynamic")
		local newChainPiece = love.physics.newCircleShape(5)
		local newFixture = love.physics.newFixture(newBody,newChainPiece)
		newFixture:setMask(2,1)
		newFixture:setCategory(2)
		newBody:setMass(0)
		local newJoints = {}
		if(i == 1) then
			local xlength = v[1] - x1
			local ylength = v[2] - y1
			local newX = x1 + xlength * 0.5
			local newY = y1 + ylength * 0.5
			newJoints[1] = love.physics.newRevoluteJoint(body1,newBody,newX,newY,false)
			print("first")
		elseif (i == #ropePoints) then
			local lastX,lastY = ropeJoint[i - 1].body:getWorldCenter()
			local xlength = v[1] - lastX
			local ylength = v[2] - lastY
			local newX = lastX + xlength * 0.5
			local newY = lastY + ylength * 0.5
			newJoints[1] = love.physics.newRevoluteJoint(ropeJoint[i - 1].body,newBody,newX,newY,false)
			local xlength = x2 - v[1]
			local ylength = y2 - v[2]
			local newX = v[1] + xlength * 0.5
			local newY = v[2] + ylength * 0.5
			newJoints[2] = love.physics.newRevoluteJoint(newBody,body2,newX,newY,false)
			print("second")
		elseif(i > 1 and i < #ropePoints) then
			local lastX,lastY = ropeJoint[i - 1].body:getWorldCenter()
			local xlength = v[1] - lastX
			local ylength = v[2] - lastY
			local newX = lastX + xlength * 0.5
			local newY = lastY + ylength * 0.5
			newJoints[1] = love.physics.newRevoluteJoint(ropeJoint[i - 1].body,newBody,newX,newY,false)
			print("third")
		end
		ropeJoint[#ropeJoint + 1] = {}
		ropeJoint[#ropeJoint].body = newBody
		ropeJoint[#ropeJoint].chainPiece = newChainPiece
		ropeJoint[#ropeJoint].fixture = newFixture
		ropeJoint[#ropeJoint].joints = newJoints
	end
	return ropeJoint
end

function destroyOldRope()
	for i,v in pairs(newRopeJoint) do
		v.body:destroy()
	end
end